#if !defined(_smart_output_h_inc_)
#define _smart_output_h_inc_

class SEModule_base;

// this class simplifies keeping track of an output plug.
// it sends the status change messages for you, and saves CPU whenever posible
class smart_output
{
public:
	smart_output(SEModule_base *p_module, int p_plug_number);
	~smart_output(void);
	float **PointerAddress(){return &output_buffer_ptr;};
	void process( int buffer_position, int sampleframes);
	void SetValue(unsigned int p_sample_clock, float p_newvalue);
	float GetValue(void){return m_current_output_value;};
//	void SetPin(SEPin *p_pin){m_pin=p_pin;};
private:
	float *output_buffer_ptr;
	float m_current_output_value;
	SEModule_base *m_module;
	int m_pin_number;
	int static_output_count;
};

#endif
