#pragma once
#include "segui_base.h"

#define WS_NODE_COUNT 11

struct mypoint
{
	mypoint(float px=0, float py=0){x=px;y=py;};
	mypoint(mypoint &other){x=other.x;y=other.y;};
	float x;
	float y;
};

class GuiModule :
	public SEGUI_base
{
public:
	GuiModule(seGuiCallback seaudioMaster, void *p_resvd1);
	virtual void paint(HDC hDC, SEWndInfo *wi);
	virtual void OnLButtonDown( SEWndInfo *wi, UINT nFlags, sepoint point );
	virtual void OnLButtonUp( SEWndInfo *wi, UINT nFlags, sepoint point );
	virtual void OnMouseMove( SEWndInfo *wi, UINT nFlags, sepoint point );
	virtual void OnModuleMsg(int p_user_msg_id,int p_length, void * p_data);
	void Initialise(bool loaded_from_file);
	virtual void OnGuiPinValueChange(SeGuiPin *p_pin);
	static void UpdateNodes( mypoint *nodes, const SeSdkString &p_values );
private:
	static float StringToFloat(const SeSdkString &p_string);
	SeSdkString DefaultValue();
	SeSdkString GetValueS();
	void SetValueS(SeSdkString p_string);
	void OnValueChanged();
	void DrawScale( HDC hDC, SEWndInfo *wi );
	void SendStringToAudio( int p_length, void *p_data );
	int Handle(void);
	int InvalidateControl(void);
	mypoint nodes[WS_NODE_COUNT]; // x,y co-ords of control points
	int drag_node;
	sepoint m_ptPrev;
	bool m_inhibit_update;
};
